# Contributing to floWeaver

Thanks for your interest in contributing to floWeaver! :tada: 

floWeaver is an open Python framework to help exchange and analyse flow data and visualise it using Sankey diagrams. There are lots of ways you can get involved and help, from sharing examples of work done using it, providing feedback, improving the documentation and identifying and fixing bugs in the code. See the ["what shall I do?!" board](https://github.com/ricklupton/floweaver/projects/3) for examples!

This document is a set of guidelines for contributing to floWeaver on GitHub. These are guidelines, not rules. This guide is meant to make it easy for you to get involved.

## Participation guidelines

This project adheres to a [code of conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to Rick Lupton <mail@ricklupton.name>.

## What we're working on

For an overview of what's happening, we have a
[detailed Roadmap](https://github.com/ricklupton/floweaver/projects/2) showing what we
are working on up to May 2018; beyond that there is the
[longer-term Roadmap](https://github.com/ricklupton/floweaver/projects/1).

Browse some good first bugs arranged by types of contribution on the ["what shall I do?!" board](https://github.com/ricklupton/floweaver/projects/3) or see the full list of [good first bugs](https://github.com/ricklupton/floweaver/labels/good%20first%20bug) to get started! If you have any questions please get in touch (see below).

The project is split between 3 repositories:
- The floWeaver Python package (**this repository**): data aggregation, preparation, conversion
- The [d3-sankey-diagram](https://github.com/ricklupton/d3-sankey-diagram): layout, SVG rendering of Sankey diagrams
- The [ipysankeywidget](https://github.com/ricklupton/ipysankeywidget): embed d3-sankey-diagram within Jupyter notebooks

![project components](docs/project_components.png)

## How to submit changes

Once you've identified one of the issues above that you feel you can contribute to, you're ready to make a change to the project repository!
 
1. **[Fork](https://help.github.com/articles/fork-a-repo/) this repository**. This makes your own version of this project you can edit and use.
2. **[Make your changes](https://guides.github.com/activities/forking/#making-changes)**! You can do this in the GitHub interface on your own local machine. Once you're happy with your changes...
3. **Submit a [pull request](https://help.github.com/articles/proposing-changes-to-a-project-with-pull-requests/)**. This opens a discussion around your project and lets the project lead know you are proposing changes.

First time contributing to open source? Check out this *free* series, [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github). If you have any problems, get in touch (see below).

## Reporting bugs and share how you find using floWeaver

We want to know if you find a bug, have trouble using floWeaver, but also if you use it successfully! Please file bugs, requests or questions in our [issue tracker](https://github.com/ricklupton/floweaver/issues/new), including:
- sharing examples of how you are using floWeaver, 
- suggestions for improving the documentation,
- examples of things that are more difficult than they should be or don't work

## Communication channels

The main communication channel is through [GitHub issues](https://github.com/ricklupton/floweaver/issues). You can also use the [Gitter chatroom](https://gitter.im/floweaver/Lobby) for discussion and questions.
